
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Winform开发框架之客户关系管理系统(CRM)的开发总结系列3-客户分类和配置管理实现 / iVAN</title>

    <meta name="description" content="Winform开发框架之客户关系管理系统(CRM)的开发总结系列3-客户分类和配置管理实现 我在本系列随笔的开始,介绍了CRM系统一个重要的客户分类的展示界面,其中包含了从字典中加载分类.从已有数据中加载分类.以及分组列表中加载分类等方式的实现,以及可以动态对这些节点进行配置,实现客户分类的界面配置处理.本文主要从逻辑代码实现的角度上解说以上功能的实现,介绍常规字典模块的动态加载.客户省份城市的动态加载.客户分组管理.客户分类配置管理等模块的具体实现. 一般情况下,我们对客户的分类都需要动态加载,对这个客户分类的管理,包括下面几种分类. 1.常规字典模块的动态加载    以上节点是从字">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">Winform开发框架之客户关系管理系统(CRM)的开发总结系列3-客户分类和配置管理实现</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>我在本系列随笔的开始，介绍了CRM系统一个重要的客户分类的展示界面，其中包含了从字典中加载分类、从已有数据中加载分类、以及分组列表中加载分类等方式的实现，以及可以动态对这些节点进行配置，实现客户分类的界面配置处理。本文主要从逻辑代码实现的角度上解说以上功能的实现，介绍常规字典模块的动态加载、客户省份城市的动态加载、客户分组管理、客户分类配置管理等模块的具体实现。</p>
<p>一般情况下，我们对客户的分类都需要动态加载，对这个客户分类的管理，包括下面几种分类。</p>
<h3><strong>1、常规字典模块的动态加载</strong></h3>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzg4NjcvMjAxMzExLzEzMjIyMjAzLWUwMDFlYjg4MDIwMDQ5YjFiZWU1MzE2ZTljM2U5YjdiLnBuZw==.jpg">  <img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzg4NjcvMjAxMzExLzEzMjIyNDU2LWQ1YzNmMjg3YmU4MDQ1M2M4ZTFhYjA0ODFlZjNiNTg2LnBuZw==.jpg"></p>
<p>以上节点是从字典模块的数据里面进行动态加载的，根据节点的不同，显示的内容不同。</p>
<p>首先我们需要在数据库里面建立一个表，用来记录需要显示的大的分类节点，如客户状态、客户类型、客户级别这些层次的节点，如下所示。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzg4NjcvMjAxMzExLzIwMjMxMDU2LWE2ZjU4ZTMwN2IxMzQ4ZmVhOGYxY2FlYTdkYTQ4MDQwLnBuZw==.jpg"></p>
<p>根据这个表的内容指引，我们在动态加载里面的子节点。</p>
<pre>            TreeNode topNode = new TreeNode("全部客户", 0, 0);
            this.treeView1.Nodes.Add(topNode);

            List&lt;SystemTreeNodeInfo&gt; propList = BLLFactory&lt;SystemTree&gt;.Instance.GetTree("客户属性分类");
            foreach (SystemTreeNodeInfo nodeInfo in propList)
            {
                if (ContainTree(nodeInfo.ID))
                {
                    TreeNode subNode = new TreeNode(nodeInfo.TreeName, 1, 1);
                    AddSystemTree(nodeInfo.Children, subNode, 2);
                    this.treeView1.Nodes.Add(subNode);
                }
            }
            this.treeView1.ExpandAll();

            for (int i = 0; i &lt; this.treeView1.Nodes.Count; i++)
            {
                TreeNode node = this.treeView1.Nodes[i];
                AddDictData(node, 3);
            }</pre>
<p> 其中使用递归函数进行创建树节点，也就是树节点可以是多层级的。</p>
<pre>        /// &lt;summary&gt;
        /// 从系统树形表里面获取数据，绑定客户属性分类和客户状态分类
        /// &lt;/summary&gt;
        private void AddSystemTree(List&lt;SystemTreeNodeInfo&gt; nodeList, TreeNode treeNode, int i)
        {
            foreach (SystemTreeNodeInfo nodeInfo in nodeList)
            {
                if (ContainTree(nodeInfo.ID))
                {
                    TreeNode subNode = new TreeNode(nodeInfo.TreeName, i, i);
                    subNode.Tag = nodeInfo.SpecialTag;//用来做一定的标识
                    treeNode.Nodes.Add(subNode);

                    AddSystemTree(nodeInfo.Children, subNode, i + 1);
                }
            }
        }</pre>
<p>上面代码首先从一个SystemTree的业务对象里面加载列表信息，然后通过一个递归函数<strong>AddSystemTree</strong>实现节点的加载。</p>
<p>加载大的树节点完毕后，我们就从字典中获取对应的字典项目属性进行加载了，我们不管上面的树节点是集成，我们只需要知道，上面每一个节点都从数据库获取对应的项目进行绑定即可，从字典加载子节点的代码逻辑如下所示。</p>
<pre>                List&lt;DictDataInfo&gt; dict = BLLFactory&lt;DictData&gt;.Instance.FindByDictType(treeNode.Text);
                foreach (DictDataInfo info in dict)
                {
                    if (ContainTree(info.ID))
                    {
                        TreeNode subNode = new TreeNode(info.Name, i, i);
                        if (treeNode.Tag != null)
                        {
                            subNode.Tag = string.Format("{0}='{1}' ", treeNode.Tag, info.Value);
                        }
                        treeNode.Nodes.Add(subNode);
                    }
                }</pre>

<h3>2、<strong>客户省份、客户城市的动态加载</strong></h3>
<p>除了从数据字典中加载的节点数据，还有一种如客户省份、客户城市，我们知道这些数据很大，我们如果在树列表里面展示全国的城市，那么肯定是不好的用户体验，想想要在全国几百个城市找一个出来可不容易。</p>
<p>于是，可以设计从已有客户所在的省份、所在的城市，把他们动态加载出来，数据就少很多，友好很多，界面效果图如下所示。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzg4NjcvMjAxMzExLzEzMjIzOTU1LTMzYWZlMTFjNjdkNTRhYzFhMjVmNWFjZjBiZjg0ZDUzLnBuZw==.jpg">   <img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzg4NjcvMjAxMzExLzEzMjI0MTE3LTE0NmY4OTA4OTJiNzRmMDNiZmY3Y2Q2NzM1NDQ1NDY4LnBuZw==.jpg"></p>
<p>刚才我们看到了，从数据字典中动态加载子节点的操作了，其实这个和上面的操作类似，只是获取数据源的地方不同而已，我们可以根据树的节点（特殊节点）来对数据源进行不同的加载，具体如下代码所示。</p>
<pre>        /// &lt;summary&gt;
        /// 从数据库获取对应字典数据，并绑定到相关节点上
        /// &lt;/summary&gt;
        private void AddDictData(TreeNode treeNode, int i)
        {
            string nodeText = treeNode.Text;
            if (nodeText == "客户省份")
            {
                List&lt;string&gt; provinceList = BLLFactory&lt;Customer&gt;.Instance.GetCustomersProvince();
                foreach (string province in provinceList)
                {
                    TreeNode subNode = new TreeNode(province, i, i);
                    if (treeNode.Tag != null)
                    {
                        subNode.Tag = string.Format("{0}='{1}' ", treeNode.Tag, province);
                    }
                    treeNode.Nodes.Add(subNode);
                }
            }
            else if (nodeText == "客户城市")
            {
                List&lt;string&gt; cityList = BLLFactory&lt;Customer&gt;.Instance.GetCustomersCity();
                foreach (string city in cityList)
                {
                    TreeNode subNode = new TreeNode(city, i, i);
                    if (treeNode.Tag != null)
                    {
                        subNode.Tag = string.Format("{0}='{1}' ", treeNode.Tag, city);
                    }
                    treeNode.Nodes.Add(subNode);
                }
            }</pre>
<p>通过预先在节点里面定义一些属性，我们就能构建一个可以查询出正确数据的过滤语句了，然后在树的AfterSelect事件里面实现对条件语句的查询即可。</p>
<pre>        string treeConditionSql = "";
        private void treeView1_AfterSelect(object sender, TreeViewEventArgs e)
        {
            if (e.Node != null)
            {
                //需要清空查询输入条件
                this.customGridLookUpEdit1.EditValue = null;

                if (e.Node.Tag != null &amp;&amp; !string.IsNullOrEmpty(e.Node.Tag.ToString()))
                {
                    treeConditionSql = e.Node.Tag.ToString();
                    BindData();
                }
.....................</pre>
<p>树的动态加载在很多地方都可以用到，例如下面的界面中，我对订单的各种属性状态进行了分类，方便操作。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzg4NjcvMjAxMzExLzIxMTAzODI5LWI1ODdiNDAwMzY0MjQ2M2NiNjY3MWViMDVjY2FkNWMxLnBuZw==.jpg"></p>
<h3><strong>3、客户分组的管理</strong></h3>
<p>除了上面两种，还有一种来自个人的客户组别的数据表数据，我们从其中获取到对应的客户分组信息，然后在客户分组节点中展示出来，选择对应的个人分组就可以获取对应的客户。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzg4NjcvMjAxMzExLzEzMjI0NjMyLWIwNDkxYWViZDg5MzQ5YzM4NTFlODYwZmJlYWJmMGRiLnBuZw==.jpg"></p>
<p>上面的个人分组来自对客户的个人分组表里面，它的管理界面如下所示。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzg4NjcvMjAxMzExLzEzMjI0NzM1LTc1MTc3MTc0MzI5ZjQwOGJhMmZlOTExZGIzYTMxYjUyLnBuZw==.jpg"></p>
<p>个人分组的子节点加载操作代码如下所示，其中除了加载已有的客户分组外，还增加两个分组名称，如“未分组客户”和“全部客户”，方便操作。</p>
<pre>            TreeNode myGroupNode = new TreeNode("个人分组", 4, 4);
            List&lt;CustomerGroupNodeInfo&gt; groupList = BLLFactory&lt;CustomerGroup&gt;.Instance.GetTree(LoginUserInfo.Name);
            AddCustomerGroupTree(groupList, myGroupNode, 3);
            //添加一个未分类和全部客户的组别
            myGroupNode.Nodes.Add(new TreeNode("未分组客户", 3, 3));
            myGroupNode.Nodes.Add(new TreeNode("全部客户", 3, 3));

            this.treeView1.Nodes.Add(myGroupNode);
            myGroupNode.ExpandAll();</pre>
<pre>        /// &lt;summary&gt;
        /// 获取客户分组并绑定
        /// &lt;/summary&gt;
        private void AddCustomerGroupTree(List&lt;CustomerGroupNodeInfo&gt; nodeList, TreeNode treeNode, int i)
        {
            foreach (CustomerGroupNodeInfo nodeInfo in nodeList)
            {
                if (ContainTree(nodeInfo.ID))
                {
                    TreeNode subNode = new TreeNode(nodeInfo.Name, i, i);
                    treeNode.Nodes.Add(subNode);

                    AddCustomerGroupTree(nodeInfo.Children, subNode, i);
                }
            }
        }</pre>
<p>然后在AfterSelect事件中处理即可实现对应数据的查询操作了。</p>
<pre>                    else if (e.Node.FullPath.IndexOf("个人分组") &gt;= 0)
                    {
                        if (e.Node.Text == "全部客户")
                        {
                            treeConditionSql = "";
                            BindData();
                        }
                        else if (e.Node.Text == "未分组客户")
                        {
                            isUserGroupName = true;
                            BindDataWithGroup(null);
                        }
                        else
                        {
                            isUserGroupName = true;
                            BindDataWithGroup(e.Node.Text);
                        }
                    }</pre>
<pre>        private void BindDataWithGroup(string groupName)
        {
            //entity
            this.winGridViewPager1.DisplayColumns = displayColumns;
            this.winGridViewPager1.ColumnNameAlias = BLLFactory&lt;Customer&gt;.Instance.GetColumnNameAlias();//字段列显示名称转义

            List&lt;CustomerInfo&gt; list = BLLFactory&lt;Customer&gt;.Instance.FindByGroupName(LoginUserInfo.Name, groupName, this.winGridViewPager1.PagerInfo);
            this.winGridViewPager1.DataSource = new WHC.Pager.WinControl.SortableBindingList&lt;CustomerInfo&gt;(list);
            this.winGridViewPager1.PrintTitle = "客户信息列表";
        }</pre>
<p>上面的代码中用到了当前用户的登陆名称作为一个标识（LoginUserInfo.Name），用来仅仅获取当前用户的分组信息的。</p>
<h3><strong>4、客户分类的配置管理</strong></h3>
<p>从上面对客户的分类，我们看到已经有很多大的类别了，每个类别展开还有好几项，这样就构成了一个很大的树，但是有时候有些客户可能不一定对所有的分类节点都感兴趣，如果能够给客户一个选择配置的机会，会显得更加友好</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzg4NjcvMjAxMzExLzEzMjI1MjM5LWFjNjUwZWQ1MmQyYzQxM2RhNjc1ZmNkNmI0M2ZkZjIxLnBuZw==.jpg"> </p>
<p> 上面我们提供了一个单独的界面元素配置窗口给用户进行自定义的树节点配置，我们约定默认（在用户还没有保存配置的时候）是把所有节点勾选上去，如果用户选定并保存了，那么以用户配置的为准来加载树列表。</p>
<p>下面我们来看看具体如何实现这个操作的。</p>
<p>首先我们在用户初始化树的时候，把用户的保存列表获取到，并保存在一个局部变量里面，方便对节点进行判断，如下代码所示。</p>
<pre>        private void InitTree()
        {
            userTreeList = BLLFactory&lt;UserTreeSetting&gt;.Instance.GetTreeSetting(treeCategory, LoginUserInfo.ID.ToString());</pre>
<p>然后我们编写一个函数，用来判断是否需要勾选上去。刚才说到，默认如果没有保存，则需要勾选上去。</p>
<pre>        /// &lt;summary&gt;
        /// 如果列表为空或包含指定ID，则认为包含
        /// &lt;/summary&gt;
        /// &lt;param name="id"&gt;树ID节点&lt;/param&gt;
        /// &lt;returns&gt;&lt;/returns&gt;
        private bool ContainTree(string id)
        {
            bool result = false;
            if (userTreeList == null || userTreeList.Count == 0 || userTreeList.Contains(id))
            {
                result = true;
            }
            return result;
        }</pre>
<p>然后我们添加每个树节点的时候，使用这个函数判断是否勾选上去即可，注意每个节点的Tag使用了一个GUID作为记录，方便保存。</p>
<pre>            List&lt;SystemTreeNodeInfo&gt; propList = BLLFactory&lt;SystemTree&gt;.Instance.GetTree("客户属性分类");
            foreach (SystemTreeNodeInfo nodeInfo in propList)
            {
                TreeNode subNode = new TreeNode(nodeInfo.TreeName, 1, 1);
                subNode.Tag = nodeInfo.ID;
                subNode.Checked = ContainTree(nodeInfo.ID);

                AddSystemTree(nodeInfo.Children, subNode, 2);
                this.treeView1.Nodes.Add(subNode);
            }
            this.treeView1.ExpandAll();</pre>
<p>最后，保存节点的时候，我们遍历每个节点的Tag的GUID内容，然后把它保存到用户配置表里面即可。</p>
<pre>        private void btnOK_Click(object sender, EventArgs e)
        {
            List&lt;string&gt; nodeIdList = new List&lt;string&gt;();
            foreach (TreeNode node in this.treeView1.Nodes)
            {
                if (node.Checked &amp;&amp; node.Tag != null &amp;&amp; !string.IsNullOrEmpty(node.Tag.ToString()))
                {
                    nodeIdList.Add(node.Tag.ToString());
                }
                nodeIdList.AddRange(GetNodeIdList(node));
            }

            bool result = BLLFactory&lt;UserTreeSetting&gt;.Instance.SaveTreeSetting(treeCategory, LoginUserInfo.ID.ToString(), nodeIdList);
            if (result)
            {
                ProcessDataSaved(null, null);
                MessageDxUtil.ShowTips("保存成功");
            }
            this.Close();
        }</pre>
<p>通过以上这些操作，我们就能在配置界面中，显示用户的选择节点，然后可以保存用户的选择内容到一个单独的配置表里面，在正式的树列表中，我们用同样的方法来判断用户是否勾选了对应的节点，如果没有勾选，那么我们不要创建这个节点即可，如下面的代码所示。</p>
<pre>            List&lt;SystemTreeNodeInfo&gt; propList = BLLFactory&lt;SystemTree&gt;.Instance.GetTree("客户属性分类");
            foreach (SystemTreeNodeInfo nodeInfo in propList)
            {
                if (ContainTree(nodeInfo.ID))
                {
                    TreeNode subNode = new TreeNode(nodeInfo.TreeName, 1, 1);
                    AddSystemTree(nodeInfo.Children, subNode, 2);
                    this.treeView1.Nodes.Add(subNode);
                }
            }</pre>
<p>以上就是我的CRM系统模块里面的一些常用界面元素具体实现逻辑，希望对大家分析学习有帮助。</p>
<p>本CRM系统主要是基于我的《<a href="http://www.iqidi.com/Framework/info.html?flag=3" rel="external nofollow noreferrer">Winform开发框架</a>》基础上进行的模块开发，其中整合了整个框架体系里面的权限管理模块、字典管理模块、Winform分页控件、公用类库、自动更新模块、附件管理模块、人员管理模块，以及后续可能需要整合的流程管理模块、邮件收发服务模块、信息通知模块等一系列内容，希望开发出一个高效、易用的客户管理系统，同时也希望藉此系统的开发实践，进一步改进我的代码生成工具，以及进一步完善Winform开发框架各模块的内容，达到新的一个高度。</p>
<p>《<a href="http://www.iqidi.com/Framework/info.html?flag=3" rel="external nofollow noreferrer">Winform开发框架</a>》的主要功能概览如下图所示。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzg4NjcvMjAxMzA3LzE5MDgzMDIwLTI4MDE2ZDQ3ZTc0YTRlZDk5MzVkODYzNjY5NjE1Y2JjLnBuZw==.jpg"></p>
<p>我的该CRM系统系列的几篇随笔链接如下，供阅读。</p>
<p><a href="http://www.cnblogs.com/wuhuacong/p/3422279.html" rel="external nofollow noreferrer">Winform开发框架之客户关系管理系统(CRM)的开发总结系列1-界面功能展示</a> </p>
<p><a href="http://www.cnblogs.com/wuhuacong/p/3434321.html" rel="external nofollow noreferrer">Winform开发框架之客户关系管理系统(CRM)的开发总结系列2-基于框架的开发过程</a> </p>
<p><a href="http://www.cnblogs.com/wuhuacong/p/3434641.html" rel="external nofollow noreferrer">Winform开发框架之客户关系管理系统(CRM)的开发总结系列3-客户分类和配置管理实现</a> </p>
<p><a href="http://www.cnblogs.com/wuhuacong/p/3435297.html" rel="external nofollow noreferrer">Winform开发框架之客户关系管理系统(CRM)的开发总结系列4-Tab控件页面的动态加载</a> </p>
<p>本文转自博客园伍华聪的博客，原文链接：<a href="http://www.cnblogs.com/wuhuacong/p/3434641.html" rel="external nofollow noreferrer">Winform开发框架之客户关系管理系统(CRM)的开发总结系列3-客户分类和配置管理实现</a>，如需转载请自行联系原博主。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 18:42:49</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%a8%a1%e5%9d%97/" title="模块">模块</a>, <a href="https://www.iamivan.net/tag/%e9%85%8d%e7%bd%ae/" title="配置">配置</a>, <a href="https://www.iamivan.net/tag/string/" title="string">string</a>, <a href="https://www.iamivan.net/tag/list/" title="list">list</a>, <a href="https://www.iamivan.net/tag/add/" title="ADD">ADD</a>, <a href="https://www.iamivan.net/tag/%e5%bc%80%e5%8f%91%e6%a1%86%e6%9e%b6/" title="开发框架">开发框架</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>Winform开发框架之客户关系管理系统(CRM)的开发总结系列3-客户分类和配置管理实现的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p86LZVb.html" rel="bookmark">Winform开发框架之客户关系管理系统&lpar;CRM&rpar;的开发总结系列2-基于框架的开发过程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在上篇随笔&lt;Winform开发框架之客户关系管理系统(CRM)的开发总结系列1-界面功能展示&gt;中介绍了我的整个CRM系统的概貌,本篇继续本系列的文章,介绍如何基于我的&lt;winform开发框架&gt;的基础上进行CRM系统模块的开发工作,希望对大家在系统模块开发有所启示或者帮助. 在我整个开发框架的体系结构中,我都希望开发的业务模块尽可能重用,因此遵循这个要求,所有的模块除了一些基础模块外,尽可能和其他业务模块没有任何耦合关系,同时也可以动态对模块进行加载使用,和我在&lt;Winform			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z76L2qp.html" rel="bookmark">Winform开发框架之客户关系管理系统&lpar;CRM&rpar;的开发总结系列4-Tab控件页面的动态加载</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在前面介绍的几篇关于CRM系统的开发随笔中,里面都整合了多个页面的功能,包括多文档界面,以及客户相关信息的页面展示,这个模块就是利用DevExpress控件的XtraTabPage控件的动态加载实现的,本篇文章主要介绍两种方式的动态加载,一个是对用户控件(UserControl)模块的动态加载,一个是对普通窗体(Form)的动态加载,通过这两种方式,我们有时候可以动态实现很丰富的界面效果. 1.用户控件(UserControl)模块在Tab控件中的动态加载 参考了很多CRM的系统,一般都是把CR			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zeayZVz.html" rel="bookmark">Winform开发框架之客户关系管理系统&lpar;CRM&rpar;的开发总结系列1-界面功能展示</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一直以来,都希望整合一个以客户为中心的平台,有两个方面的考虑:一是实现客户数据.客户关系.客户管理等方面的整合,以便更好利用好客户的相关资源,发挥最大的营销效益:二是整合目前我的开发框架的所有模块和技术,包括权限管理和控制.字典管理模块.分页控件.公用类库.自动更新模块.附件管理模块.邮件短信的信息通知模块.工作流模块,以及来电显示记录模块.群发邮件营销模块.日历管理模块等方面的内容.本随笔系列主要介绍在开发我的CRM系统中的各种场景问题的解决思路,以及相关的功能实现,力求在逐步完善这个CRM系			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p8j2nlb.html" rel="bookmark">Winform开发客户关系管理系统&lpar;CRM&rpar;总结 2 基于框架的开发过程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在上篇随笔&lt;Winform开发框架之客户关系管理系统(CRM)的开发总结系列1-界面功能展示&gt;中介绍了 我的整个CRM系统的概貌,本篇继续本系列的文章,介绍如何基于我的&lt;winform开发框架&gt;的基础上进 行CRM系统模块的开发工作,希望对大家在系统模块开发有所启示或者帮助. 在我整个开发框架的体系结构中,我都希望开发的业务模块尽可能重用,因此遵循这个要求,所有的 模块除了一些基础模块外,尽可能和其他业务模块没有任何耦合关系,同时也可以动态对模块进行加载 使用,和我在&lt;Win			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bQP3Zwz.html" rel="bookmark">Winform开发框架之客户关系管理系统&lpar;CRM&rpar;的报价单和销售单的处理</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在前面介绍了很多CRM相关的界面和实现思路的随笔文章,本篇继续介绍一下系统中用到的一些经验 和技巧片段.本篇随笔主要介绍客户关系管理系统(CRM)的报价单和销售单的处理界面效果,使用列表内 置的选择代替弹出对话框选择产品的方式,实现报价单和销售单的产品列表快速选择. 1.功能界面效果展示 我们知道,在很多列表的内容输入中,很多都使用内置的列表选择方式代替弹出式对话框的选择方式 ,在我研究了解的很多个CRM系统中,报价单和销售单都基本上是采用这种内置的选择方式,为了适应业 界的标准习惯,我在我的系			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b3NRLAz.html" rel="bookmark">Winform开发客户关系管理系统&lpar;CRM&rpar;总结 3 客户分类和配置管理实现</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				我在本系列随笔的开始,介绍了CRM系统一个重要的客户分类的展示界面,其中包含了从字典中加载 分类.从已有数据中加载分类.以及分组列表中加载分类等方式的实现,以及可以动态对这些节点进行 配置,实现客户分类的界面配置处理.本文主要从逻辑代码实现的角度上解说以上功能的实现,介绍常 规字典模块的动态加载.客户省份城市的动态加载.客户分组管理.客户分类配置管理等模块的具体实 现. 一般情况下,我们对客户的分类都需要动态加载,对这个客户分类的管理,包括下面几种分类. 1.常规字典模块的动态加载 开发客户关系			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/ze42O8p.html" rel="bookmark">客户关系管理系统&lpar;CRM&rpar;的开发过程中使用到的开发工具总结</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				开发&lt;客户关系管理系统(CRM)&gt;软件过程,也就是一个标准的Winform程序的开发过程,我们可以通 过这个典型的软件开发过程来了解目前的开发思路.开发理念,以及一些必要的高效率手段.本篇随笔 主要介绍我在开发这个CRM客户关系管理系统过程中,所用到的一些开发工具,力求从开发工具的层面使 大家对这个系统的形成过程有一个大致的了解. 在文章的开篇,我们先来聊几句.一直以来,我都知道,广州这个城市,在图书馆建设方面都做的很 好,提供了很多公众的借阅服务,几年前也曾经在区一个小的图书馆里借阅过书籍,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/baloPNz.html" rel="bookmark">Winform开发客户关系管理系统&lpar;CRM&rpar;总结 1 界面功能展示</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一直以来,都希望整合一个以客户为中心的平台,有两个方面的考虑:一是实现客户数据.客户关系 .客户管理等方面的整合,以便更好利用好客户的相关资源,发挥最大的营销效益:二是整合目前我的 开发框架的所有模块和技术,包括权限管理和控制.字典管理模块.分页控件.公用类库.自动更新模 块.附件管理模块.邮件短信的信息通知模块.工作流模块,以及来电显示记录模块.群发邮件营销模 块.日历管理模块等方面的内容.本随笔系列主要介绍在开发我的CRM系统中的各种场景问题的解决思路 ,以及相关的功能实现,力求在逐步完善这			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zOw3N5z.html" rel="bookmark">Winform开发客户关系管理系统&lpar;CRM&rpar;总结 4 Tab控件页面的动态加载</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在前面介绍的几篇关于CRM系统的开发随笔中,里面都整合了多个页面的功能,包括多文档界面,以 及客户相关信息的页面展示,这个模块就是利用DevExpress控件的XtraTabPage控件的动态加载实现的, 本篇文章主要介绍两种方式的动态加载,一个是对用户控件(UserControl)模块的动态加载,一个是对 普通窗体(Form)的动态加载,通过这两种方式,我们有时候可以动态实现很丰富的界面效果. 1.用户控件(UserControl)模块在Tab控件中的动态加载 参考了很多CRM的系统,一般都是			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/1MvYN6b.html" rel="bookmark" class="title">maven &plus; sonar&comma; gradle &plus; sonar</a>
					<div>
						sonar installation and configuration Download sonar http://downloads.sonarsource.com/sonarqube/ Deco ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/2MWm6nz.html" rel="bookmark" class="title">&period;NET MVC一起使用jQuery</a>
					<div>
						jQuery是一款容易上手的JavaScript库,任何Web开发平台都可以使用,它跟ASP.NET MVC框架的结合尤为引人瞩目.James Estes曾在InfoQ上发表过一篇文章,名为jQuer ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/2MWmajz.html" rel="bookmark" class="title">一段优化排序的Sql语句</a>
					<div>
						排序|优化|语句 if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[OrderOptimize]') and  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Xpmqw3p.html" rel="bookmark" class="title">JBoss配置mysql数据源</a>
					<div>
						mysql|数据|数据源 编写mysql-ds.xml并放在server/default/deploy(如果使用default作为server的话) &lt;?xml version=&quot;1. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/yMA5lnM.html" rel="bookmark" class="title">JSF Spring Hibernate整合：JSH1</a>
					<div>
						JSF1.1 + Spring2.0 + Hibernate3.1 图示: JSF1.1 Jar包 : MyFaces1.1 Jar包: Spring与Hibernate包的配置与文章&lt;SSH1 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW1B9Xz.html" rel="bookmark" class="title">如何在vs 2012中安装ArcObjects SDK（AE）10&period;1</a>
					<div>
						ArcObjects SDK(以下简称AO)10.1只支持vs2010,如果装了vs2012,再安装AO会提示一串鸡肠(英文),意思是AO10.1只支持vs2010 想在2012下安装,可以通过修改注 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQP1ROz.html" rel="bookmark" class="title">网页开发常用的6种在线调试环境</a>
					<div>
						如今的网页代码,一般由三个部分组成: * HTML,语义层,提供网页的内容. * CSS,表现层,规定网页的外观. * Javascript,动作层,定义用户与网页的互动. 理想的开发环境,应该既可以 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0Pg4AM.html" rel="bookmark" class="title">别让Hibernate偷走了你的标识符</a>
					<div>
						摘要: 当对象持久化到数据库中时,对象的标识符总时很难被恰当的实现.尽管如此,问题其实完全是由存在着在保存之前不持有ID的对象的现象衍生而来的.我们可以通过从诸如Hibernate这样的对象-关系映像 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo68mvz.html" rel="bookmark" class="title">在ppt中插入背景音乐的技巧</a>
					<div>
						    powerpoint可以向幻灯片中插入CD音乐,WAV,MIDI和MP3文件以及录音旁白,但是用这些方法插入背景音乐时会出现一个光碟或者喇叭的小图标,虽然可以在播放时隐藏它,但是在编辑状态下往 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqL6jKb.html" rel="bookmark" class="title">Win7电脑中的mrt&period;exe是什么文件</a>
					<div>
						  1.一些优化软件可以检测到mrt.exe文件占用CPU很高! 2.如果没有优化软件,按三键(Ctrl+Alt+Del)调出[Windows任务管理器]→进程→也会看到mrt.exe文件占用cpu很 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pP88r1p.html" rel="bookmark" class="title">酷盘提示发起分享文件功能被关闭如何才能打开</a>
					<div>
						  酷盘提示发起分享文件功能被关闭的解决方法如下: 如果曾分享过侵权或不合法的内容,分享功能将会被关闭,想要从新开启分享功能,可以联系客服人员,客服电话&quot;400 058 8080&quot; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9EWJ4M.html" rel="bookmark" class="title">jquery实现弹出div&comma;始终显示在屏幕正中间的简单实例</a>
					<div>
						 本篇文章主要是对jquery实现弹出div,始终显示在屏幕正中间的简单实例进行了介绍,需要的朋友可以过来参考下,希望对大家有所帮助 以下代码块就能始终让弹出div位于屏幕的正中心,希望对大家有所帮助 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQNYQWM.html" rel="bookmark" class="title">如何整理word中制作流程图的多个形状</a>
					<div>
						  1.我们在做流程图的时候会在word中插入多个形状,尤其是流程图的时候会用到很多图形,但使用起来的时候没有办法一起选中,只能一个个通过Ctrl或Shift来选中,很麻烦 2.所以我们可以借鉴sma ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6ewgYb.html" rel="bookmark" class="title">如何开启苹果Mac OS X深色模式</a>
					<div>
						  如何开启苹果Mac OS X深色模式 一.苹果Mac OS深色模式是什么 深色模式是指苹果Mac桌面顶端和底部的菜单采用的那种半透明黑色模式,默认是半透明蓝色模式.如果使用浅色桌面背景图片,深色模 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MN1Pr7b.html" rel="bookmark" class="title">如何使用显卡控制台调节显示亮度（Nvidia单显卡篇）</a>
					<div>
						  操作步骤: XP系统NV显卡亮度调整设置 在桌面鼠标右键单击,在弹出的页面选择&quot;NVIDIA控制面板&quot;, 点击NVIDIA控制面板左侧的&quot;调整桌面颜色设置&quot; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9E3j3M.html" rel="bookmark" class="title">win7和win10哪个系统好</a>
					<div>
						  1.免费 想必大家都知道微软首次为win10开启了免费模式,只要是正版的win7或win8操作系统都可以通过微软推送信息来免费升级至win10草系统,这也是免费升级win10最大优势,不过对于盗版 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDYrG0b.html" rel="bookmark" class="title">防止用户利用PHP代码DOS造成用光网络带宽&lowbar;php技巧</a>
					<div>
						用PHP代码调用sockets,直接用服务器的网络攻击别的IP,常见代码如下: 复制代码 代码如下: $packets = 0; $ip = $_GET[\'ip\']; $rand = $_GET[ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlQXE8p.html" rel="bookmark" class="title">Android ARM常用的汇编指令合集</a>
					<div>
						               ARM   处理器的指令集可以分为 跳转指令.数据处理指令.程序状态寄存器(PSR)处理指令.加载/存储指令.协处理器指令和异常产生指令  六大指令,这里把其它几个指令一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bE6Od9M.html" rel="bookmark" class="title">安卓-手机安全软件一键清理的机制</a>
					<div>
						问题描述 手机安全软件一键清理的机制 是依据什么里默认清理文件的,而各应用又如何保证自己存放在sd卡中的一些必要文件不被清理 解决方案 参考一下:http://blog.csdn.net/zhgxhu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5NLeRz.html" rel="bookmark" class="title">404错误页面返回的状态码是200之严重性</a>
					<div>
						&amp;http://www.aliyun.com/zixun/aggregation/37954.html&quot;&gt;nbsp; 最近在做网站的改版时发现站点的404错误页面是IIS的默认 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPPyNAp.html" rel="bookmark" class="title">架设局域网的SVN服务器</a>
					<div>
						\\192.168.4.186\d$ 1.从官方网站上下载并安装subversion服务端和软件&quot;Setup-Subversion-1.6.6.msi&quot;http://sourcef ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrWOXvp.html" rel="bookmark" class="title">甲骨文、谷歌的Java案牵动全球开发者神经</a>
					<div>
						围绕安卓侵权Java案,谷歌.甲骨文打了近六年的官司最近有所升级.一方是全球最大的互联网企业,另一方是全球最大的数据库软件公司,双方在安卓系统有无对Java专利构成侵权.JavaAPI是否受版权保护问 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0Qen6p.html" rel="bookmark" class="title">can&amp;amp&semi;&num;39&semi;t locate ExtUtils&sol;MakeMaker&period;pm in &commat;INC</a>
					<div>
						 [root@luozhonghua FCGI-0.71]# perl Makefile.PL       can't locate ExtUtils/MakeMaker.pm in @INC (@I ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmKqO5b.html" rel="bookmark" class="title">Intel安装框架爆出带本地提权的任意代码执行漏洞CVE-2017-5688</a>
					<div>
						Intel发布安全公告 ,执行使用Intel安装框架的可执行安装文件,例如Intel SSD Toolbox - v3.4.3.exe,就会出现两个漏洞,都会导致任意代码执行并提权. 受影响产品 In ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLgJ6ZM.html" rel="bookmark" class="title">猫扑实战分享：如何在预算几乎为0的情况做活动运营</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 上次有同行和我说他们的年度盛典活动 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8YVkNz.html" rel="bookmark" class="title">这个代码好用但是到第二主菜单的时候具体的显示不出来</a>
					<div>
						问题描述 &lt;!DOCTYPEHTMLPUBLIC&quot;-//W3C//DTDHTML4.0Transitional//EN&quot;&gt;&lt;HTML&gt;&lt;HEAD&gt ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZ2n55z.html" rel="bookmark" class="title">在Python中使用cookielib和urllib2配合PyQuery抓取网页信息&lowbar;python</a>
					<div>
						刚才好无聊,突然想起来之前做一个课表的点子,于是百度了起来. 刚开始,我是这样想的:在写微信墙的时候,用到了urllib2[两行代码抓网页],那么就只剩下解析html了.于是百度:python解析ht ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDk47Xp.html" rel="bookmark" class="title">Yii配置文件用法详解&lowbar;php实例</a>
					<div>
						本文详细分析了Yii配置文件的用法.分享给大家供大家参考.具体分析如下: Yii配置文件比ThinkPHP复杂多了,先把自己了解的配置记录下来,感兴趣的朋友可以参考一下: 复制代码 代码如下: &lt ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYNYr6p.html" rel="bookmark" class="title">在IE中用javascript配合&amp;amp&semi;nbsp&semi;使用first-child伪类</a>
					<div>
						制作符合web标准的网页,经常需要定义某个父元素下的第一个子(child)元素或最后一个元素,以便将其与其他元素区分开来,有利于实现某些特殊需求.最浅显的例子是,导航项目间的竖线,我们往往通过bord ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGrDdep.html" rel="bookmark" class="title">Oracle&plus;ibatis的&amp;amp&semi;amp&semi;lt&semi;select&amp;amp&semi;amp&semi;gt&semi;中resultClass是java&period;util&period;HashMap 返回结果key都是大写的变量名 如何解决</a>
					<div>
						问题描述 如题:Oracle+ibatis的&lt;select&gt;中resultClass是java.util.HashMap 返回结果key都是大写的变量名 如何解决如果用resultClas ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.028 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
